const $treeList = $('#treeList');
const $newTitelDialog = $('#newTitelDialog');

const dataSource = new kendo.data.TreeListDataSource({
    batch: true,
    expanded: true,
    sort: [
        {
            field: 'Titel',
            dir: 'asc',
        },
        {
            field: 'Position',
            dir: 'asc',
        },
    ],
    schema: {
        type: 'json',
        model: {
            id: 'Id',
            fields: {
                Pkey: {
                    type: 'number'
                },
                ParentTitel: {
                    type: 'number',
                    nullable: true,
                    validation: {
                        min: 0,
                    }
                },
                Titel: {
                    type: 'number',
                },
                Position: {
                    type: 'number',
                    nullable: true,
                    validation: {
                        min: 0,
                    }
                },
                Bezug: {
                    type: 'number'
                },
            },
            parentId: 'ParentTitel',
            expanded: true
        },
        data: 'Data',
        errors: 'Errors',
        total: 'Total',
    },
    data: [
        {
            "Pkey": 21,
            "Id": 1,
            "ParentTitel": null,
            "Titel": 1,
            "Position": null,
            "Bezeichnung": "Akquisitionskosten",
            "Bezug": 250000,
        },
        {
            "Pkey": 22,
            "Id": 4,
            "ParentTitel": null,
            "Titel": 4,
            "Position": null,
            "Bezeichnung": "Gebudeplanung",
            "Bezug": 14125000,
        },
        {
            "Pkey": 23,
            "Id": 5,
            "ParentTitel": null,
            "Titel": 5,
            "Position": null,
            "Bezeichnung": "Zustzliche Leistung",
            "Bezug": 20750000,
        },
        {
            "Pkey": 24,
            "Id": 6,
            "ParentTitel": null,
            "Titel": 6,
            "Position": null,
            "Bezeichnung": "nderungsleistung",
            "Bezug": 400000,
        },
        {
            "Pkey": 25,
            "Id": 7,
            "ParentTitel": null,
            "Titel": 7,
            "Position": null,
            "Bezeichnung": "Vertragswesen",
            "Bezug": 245000,
        },
        {
            "Pkey": 158716,
            "Id": 3,
            "ParentTitel": null,
            "Titel": 3,
            "Position": null,
            "Bezeichnung": "Honorarzuschlag",
            "Bezug": 37500,
        },
        {
            "Pkey": 158717,
            "Id": 2,
            "ParentTitel": null,
            "Titel": 2,
            "Position": null,
            "Bezeichnung": "Honorarabzug",
            "Bezug": -111250,
        },
        {
            "Pkey": 50108,
            "Id": 50108,
            "ParentTitel": 1,
            "Titel": 1,
            "Position": 1,
            "Bezeichnung": "Akquisitionskosten",
            "Bezug": 250000,
        },
        {
            "Pkey": 50109,
            "Id": 50109,
            "ParentTitel": 4,
            "Titel": 4,
            "Position": 1,
            "Bezeichnung": "Grundlagenermittlung",
        },
        {
            "Pkey": 50110,
            "Id": 50110,
            "ParentTitel": 4,
            "Titel": 4,
            "Position": 2,
            "Bezeichnung": "Vorplanung",
            "Bezug": 12500000,
        },
        {
            "Pkey": 50111,
            "Id": 50111,
            "ParentTitel": 5,
            "Titel": 5,
            "Position": 1,
            "Bezeichnung": "ZL 01 Flchenberechnung",
            "Bezug": 3750000,
        },
        {
            "Pkey": 50112,
            "Id": 50112,
            "ParentTitel": 5,
            "Titel": 5,
            "Position": 2,
            "Bezeichnung": "ZL 02 Visualisierungen",
            "Bezug": 4500000,
        },
        {
            "Pkey": 50113,
            "Id": 50113,
            "ParentTitel": 5,
            "Titel": 5,
            "Position": 3,
            "Bezeichnung": "ZL 03 Erstellung von Modellen",
            "Bezug": 12500000,
        },
        {
            "Pkey": 50114,
            "Id": 50114,
            "ParentTitel": 6,
            "Titel": 6,
            "Position": 1,
            "Bezeichnung": "AEL 01 nderung XYZ",
            "Bezug": 400000,
        },
        {
            "Pkey": 50115,
            "Id": 50115,
            "ParentTitel": 7,
            "Titel": 7,
            "Position": 1,
            "Bezeichnung": "Vertragswesen",
            "Bezug": 245000,
        },
        {
            "Pkey": 170531,
            "Id": 170531,
            "ParentTitel": 3,
            "Titel": 3,
            "Position": 1,
            "Bezeichnung": "Honorarzuschlag von Berlin, Auftrag A501005",
            "Bezug": 37500,
        },
        {
            "Pkey": 190538,
            "Id": 190538,
            "ParentTitel": 2,
            "Titel": 2,
            "Position": 1,
            "Bezeichnung": "Honorarabzug an Frankfurt, Auftrag 301004",
            "Bezug": -37500,
        },
        {
            "Pkey": 195530,
            "Id": 195530,
            "ParentTitel": 2,
            "Titel": 2,
            "Position": 2,
            "Bezeichnung": "Honorarabzug an Mnchen, Auftrag 401004",
            "Bezug": -73750,
        }
    ],
    // type: 'webapi',
    // transport: {
    //     read: {
    //         url: `/api/auftrag/${pkey}/leistungsphase`,
    //     },
    //     destroy: {
    //         url: `/api/auftrag/${pkey}/leistungsphase`,
    //         method: 'DELETE',
    //     },
    //     update: {
    //         url: `/api/auftrag/${pkey}/leistungsphase`,
    //         method: 'PUT',
    //         dataType: 'json',
    //     },
    //     create: {
    //         url: `/api/auftrag/${pkey}/leistungsphase`,
    //         method: 'POST',
    //         dataType: 'json',
    //     },
    //     idField: 'Id',
    // }
});

function onDrop(event) {
    const source = event.source;
    const destination = event.destination;
    if (destination) {
        event.preventDefault();

        const destinationPosition = destination.Position;
        const destinationTitel = destination.Titel;
        const sourcePosition = source.Position;
        const sourceTitel = source.Titel;

        if (!sourcePosition && !destinationPosition) {
            dataSource.data().forEach(item => sortTitel(item, destinationTitel, sourceTitel));

        } else if (!(!sourcePosition && destinationTitel)) {
            dataSource.data().forEach(item => sortPosition(item,
                destinationTitel,
                destinationPosition,
                sourceTitel,
                sourcePosition));

        }
        
        $treeList.data('kendoTreeList').refresh();

    }
}

function sortTitel(arrayItem, destinationTitel, sourceTitel) {
    if (arrayItem.Titel < sourceTitel && arrayItem.Titel >= destinationTitel) {
        if (arrayItem.ParentTitel) {
            arrayItem.set('Titel', (arrayItem.Titel + 1));
            arrayItem.set('ParentTitel', (arrayItem.ParentTitel + 1));
        } else {
            arrayItem.set('Titel', (arrayItem.Titel + 1));
            arrayItem.set('Id', (arrayItem.Id + 1));
        }
    } else if (arrayItem.Titel === sourceTitel) {
        if (arrayItem.ParentTitel) {
            arrayItem.set('Titel', destinationTitel);
            arrayItem.set('ParentTitel', destinationTitel);
        } else {
            arrayItem.set('Titel', destinationTitel);
            arrayItem.set('Id', destinationTitel);
        }
    } else if (arrayItem.Titel > sourceTitel && arrayItem.Titel <= destinationTitel) {
        if (arrayItem.ParentTitel) {
            arrayItem.set('Titel', (arrayItem.Titel - 1));
            arrayItem.set('ParentTitel', (arrayItem.ParentTitel - 1));
        } else {
            arrayItem.set('Titel', (arrayItem.Titel - 1));
            arrayItem.set('Id', (arrayItem.Id - 1));
        }
    }
}

function sortPosition(arrayItem, destinationTitel, destinationPosition, sourceTitel, sourcePosition) {
    if (arrayItem.Position) {
        if (arrayItem.Titel === sourceTitel && arrayItem.Position === sourcePosition) {
            arrayItem.set('Titel', destinationTitel);
            arrayItem.set('ParentTitel', destinationTitel);

            if (destinationPosition) {
                arrayItem.set('Position', destinationPosition);
            } else {
                arrayItem.set('Position', 1);
            }
        } else if (destinationTitel === sourceTitel) {
            if (destinationPosition) {
                if (arrayItem.Titel === destinationTitel && destinationPosition > sourcePosition && arrayItem.Position <= destinationPosition && arrayItem.Position >= sourcePosition) {  
                    arrayItem.set('Position', (arrayItem.Position - 1));
                } else if (arrayItem.Titel === destinationTitel && arrayItem.Position >= destinationPosition && arrayItem.Position < sourcePosition) {
                    arrayItem.set('Position', (arrayItem.Position + 1));
                }
            } else {
                if (arrayItem.Titel === destinationTitel && arrayItem.Position < sourcePosition) {
                    arrayItem.set('Position', (arrayItem.Position + 1));
                }
            }
        } else if (arrayItem.Titel === sourceTitel) {
            if (arrayItem.Position > sourcePosition) {
                arrayItem.set('Position', (arrayItem.Position - 1));
            }
        } else if (arrayItem.Titel === destinationTitel) {
            if (destinationPosition) {
                if (arrayItem.Position >= destinationPosition) {
                    arrayItem.set('Position', (arrayItem.Position + 1));
                }
            } else {
                arrayItem.set('Position', (arrayItem.Position + 1));
            }
        }
    }
}

document.addEventListener('DOMContentLoaded', async () => {
    $treeList.kendoTreeList({
        dataSource: dataSource,
        toolbar: [
            {
                imageClass: 'k-i-plus',
                name: 'createTitel',
                text: 'Neuer Titel',
                click() {
                    const $dialog = $('#newTitelDialog');
                    const dialog = $dialog.data('kendoDialog');
                    const titel = document.getElementById('Titelnummer');
                    const data = dataSource.rootNodes();
                    data.sort((item1, item2) => item2.Titel - item1.Titel);

                    $dialog.data('last-uid', data[0].uid);

                    titel.setAttribute('value', data[0].Titel);
                    dialog.open();
                },
            },
            'save',
            'cancel',
            'search',
        ],
        editable: {mode: 'popup', move: true},
        drop: onDrop,
        columns: [
            {
                field: 'Titel',
                title: 'Titel',
                editable: () => false,
                width: 120,
                locked: true
            },
            {
                field: 'Position',
                title: 'Position',
                editable: () => false,
                width: 120,
                locked: true
            },
            {
                field: 'Bezeichnung',
                title: 'Bezeichnung',
                width: 300,
                locked: true,
            },
            {
                field: 'Bezug',
                title: 'Honorar',
                width: 150,
            },
        ]
    });

    $newTitelDialog.kendoDialog({
        title: "Neuer Titel",
        width: "800px",
        model: true,
        visible: false,
        content: $('#newTitelDialogTemplate').html(),
        actions: [
            {
                text: "Speichern",
                primary: true,
                action(event) {
                    const newTitelForm = document.getElementById('newTitelForm');
                    const $newTitelForm = $(newTitelForm);
                    const validator = $newTitelForm.kendoValidator().data('kendoValidator');
                    const titelnummer = $(event.sender.element).find("#Titelnummer").val();
                    if (validator.validate()) {
                        const targetRowElement = dataSource.data().filter((item) => item.ParentTitel == null && item.Titel == titelnummer)[0];
                        const targetIdx = dataSource.indexOf(targetRowElement);
                        const newItem = {
                            Beauftragt: false,
                            Bezeichnung: $('#Bezeichnung').val(),
                            Bezug: null,
                            ParentTitel: null,
                            Pkey: null,
                            Position: null,
                            Titel: titelnummer,
                        };

                        //Repositions each row one further down. Probably room for improvement.
                        dataSource.data().forEach(item => {
                            if (item.Titel >= titelnummer) {
                                item.Titel += 1;
                                item.Id += 1;
                                item.id += 1;
                                if (item.parentId) {
                                    item.parentId += 1;
                                    item.ParentTitel += 1;
                                }
                                item.dirty = true;
                            }
                        });

                        dataSource.insert(targetIdx, newItem);
                        dataSource.add(newItem);
                        
                        updateSummenViewModel();
                    } else {
                        return false;
                    }
                }
            },
            {
                text: "Abbrechen"
            }
        ],
        open() {
            const titelInput = $('#Titelnummer').data('kendoNumericTextBox');
            let lastTitelNr = 0;
            dataSource.data().forEach(item => {
                if (item.Titel > lastTitelNr) {
                    lastTitelNr = item.Titel;
                }
            });
            titelInput.max(lastTitelNr);
            titelInput.value(4);
            $('#Bezeichnung').val('');
        }
    });
});